/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.ergebnis.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.entity.Sitze;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class SitzeExtendedDAO extends AbstractSitzeDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: CountSitzeByWahlAndErgebnisartNoFlush<br>
* Beschreibung: Dient der Bestimmung, ob für eine Ergebnisart bereits Sitze vorliegen.<br>
* EJBQL: SELECT count(s) FROM Sitze s WHERE s.ergebnis.wahl = ?1 AND s.ergebnis.ergebnisart=?2<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountSitzeByWahlAndErgebnisart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Sitze.findByCountSitzeByWahlAndErgebnisart" ,  wahl ,  ergebnisart  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountSitzeByWahlAndErgebnisart(): Miss");
        }

        cache.put(key, super.findByCountSitzeByWahlAndErgebnisart( wahl ,  ergebnisart  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountSitzeByWahlAndErgebnisart(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountSitzeByWahlAndErgebnisart( wahl ,  ergebnisart  );
}
/**
* Name: ErgebnisNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Sitze o WHERE o.ergebnis=?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Sitze> findByErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Sitze.findByErgebnis" ,  ergebnis  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByErgebnis(): Miss");
        }

        cache.put(key, super.findByErgebnis( ergebnis  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByErgebnis(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Sitze>) cache.lookup(key));
    }

    return super.findByErgebnis( ergebnis  );
}
/**
* Name: GebietNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Sitze o WHERE o.gebiet = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Sitze> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Sitze.findByGebiet" ,  gebiet  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGebiet(): Miss");
        }

        cache.put(key, super.findByGebiet( gebiet  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGebiet(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Sitze>) cache.lookup(key));
    }

    return super.findByGebiet( gebiet  );
}
/**
* Name: GruppeGebietErgebnisartAndWahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Sitze o WHERE o.gruppe =?1 AND o.gebiet=?2 AND o.ergebnis.ergebnisart=?3 AND o.ergebnis.wahl=?4<br>
* SQL: <br>
*/
@Override
public java.util.List<Sitze> findByGruppeGebietErgebnisartAndWahl( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Sitze.findByGruppeGebietErgebnisartAndWahl" ,  gruppe ,  gebiet ,  ergebnisart ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGruppeGebietErgebnisartAndWahl(): Miss");
        }

        cache.put(key, super.findByGruppeGebietErgebnisartAndWahl( gruppe ,  gebiet ,  ergebnisart ,  wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGruppeGebietErgebnisartAndWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Sitze>) cache.lookup(key));
    }

    return super.findByGruppeGebietErgebnisartAndWahl( gruppe ,  gebiet ,  ergebnisart ,  wahl  );
}
/**
* Name: GruppeImGebietAndErgebnisartNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Sitze o WHERE o.gruppe =?1 AND o.gebiet=?2 AND o.ergebnis.ergebnisart=?3<br>
* SQL: <br>
*/
@Override
public java.util.List<Sitze> findByGruppeImGebietAndErgebnisart( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Sitze.findByGruppeImGebietAndErgebnisart" ,  gruppe ,  gebiet ,  ergebnisart  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGruppeImGebietAndErgebnisart(): Miss");
        }

        cache.put(key, super.findByGruppeImGebietAndErgebnisart( gruppe ,  gebiet ,  ergebnisart  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGruppeImGebietAndErgebnisart(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Sitze>) cache.lookup(key));
    }

    return super.findByGruppeImGebietAndErgebnisart( gruppe ,  gebiet ,  ergebnisart  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
